var cookiesHost = new Object();

var privacyFeaturesCookiesObserver =
{
  observe: function(subject, topic, data) 
  {
    if (topic == "http-on-modify-request") {
      var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
      var cookie = null;

      try{
        cookie = httpChannel.getRequestHeader("Cookie");
      }
      catch(e){}



      if(httpChannel.notificationCallbacks)
      {
        var interfaceRequestor = httpChannel.notificationCallbacks.QueryInterface(Components.interfaces.nsIInterfaceRequestor);

        var targetDoc = interfaceRequestor.getInterface(Components.interfaces.nsIDOMWindow).document;

        var targetBrowserIndex = gBrowser.getBrowserIndexForDocument(targetDoc);

        if(cookie != null && targetBrowserIndex > -1 && targetDoc.location.host != httpChannel.URI.host)
        {
          var stringsBundle = document.getElementById("string-bundle");
          var messageString = stringsBundle.getString('third_party_cookie');
          var notificationBox = gBrowser.getNotificationBox();

          var blockButton = {
            _outer: self,
            label: stringsBundle.getString('block_site_cookies') + " " + httpChannel.URI.host,
            accessKey: null,
            callback:
            function blockButtonCallback(aNotification, aButtonInfo) {
              var perm = Components.classes["@mozilla.org/cookie/permission;1"].getService(Components.interfaces.nsICookiePermission);
              perm.setAccess(httpChannel.URI, Components.interfaces.nsICookiePermission.ACCESS_DENY);
              return false;
            }
          };
          buttons = [blockButton];

          var now = (new Date()).getTime();
          var time = cookiesHost[httpChannel.URI.host];


          if(time == null || (now - time > 10000))
          {
            notificationBox.appendNotification(messageString,
                                               null,
                                               null,
                                               notificationBox.PRIORITY_WARNING_MEDIUM,
                                               buttons);
          }

          cookiesHost[httpChannel.URI.host] = now;
        }//if
      }//httpChannel.notificationCallbacks
    }
   

  }
};

var PrivacyFeatures = {
  onLoad: function(e) {
    var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);

    observerService.addObserver(privacyFeaturesCookiesObserver, "http-on-modify-request", false);
  },
};

window.addEventListener("load", function(e) { PrivacyFeatures.onLoad(e); }, false); 
window.addEventListener("DOMAttrModified", function(ev) { 
    if(ev.attrName == "href"){
      var stringsBundle = document.getElementById("string-bundle");
      var messageString = stringsBundle.getString('link_rewritten');
      var notificationBox = gBrowser.getNotificationBox();
      notificationBox.appendNotification(messageString,
                                         null,
                                         null,
                                         notificationBox.PRIORITY_WARNING_MEDIUM,
                                         null);
    }
  }, false);
